# -*- coding: utf-8 -*-
"""
Created on Mon Oct 23 19:43:47 2023

@author: oscar
"""

import numpy as np
from collections import Counter
import read_cifar

def distance_matrix(M1,M2):
    # dists(i,j) = dist entre ième ligne de M1 et jème ligne de M1, soit la racine de sum((M1i,p - M2j,p)²))
    # qu'on peut simplifier en sum(M1i,p²) + sum(M2j,p²) - sum(2* M1j,p * M2i,p)

    l1=np.shape(M1)[0]
    l2=np.shape(M2)[0]
    Vect1=np.sum(M1**2,1)
    Vect2=np.sum(M2**2,1)

    Mat1=np.tile(Vect1, (l2,1))
    Mat2=np.tile(Vect2, (l1,1))
    Mat3=2*np.dot(M1,M2.T)
    
    dists=np.sqrt(Mat1.T+Mat2-Mat3)

    return dists

def knn_predict(dists,labels_train,k):
    labels_predict=np.array([])
    size_test=np.shape(dists)[1]
    for j in range(size_test):
        list_arg_min=np.argsort(dists[:,j])
        labels_sorted=[labels_train[i] for i in list_arg_min]
        k_labels=labels_sorted[:k]
        count = Counter(k_labels)

        labels_predict=np.append(labels_predict,count.most_common(1)[0][0])
    
    return labels_predict

def evaluate_knn(data_train,data_test,labels_train,labels_test,k):
    dists=distance_matrix(data_train,data_test)
    labels_predict=knn_predict(dists,labels_train,k)
    count=np.sum(labels_predict==labels_test)
    return count/np.shape(labels_predict)

if __name__ == "__main__":
    file = "./data/cifar-10-python/"
    data, labels = read_cifar.read_cifar(file)
    data_train,labels_train,data_test,labels_test=read_cifar.split_dataset(data,labels,0.9)
    print(evaluate_knn(data_train,data_test,labels_train,labels_test,20))